*:*********************************************************************
*:
*:        Program: DEMO.PRG
*:
*:         System: Foxbase Letter Utilities
*:         Author: Brian R. Toole
*:      Copyright (c) 1988, Brian R. Toole & Indiana Micrographics
*:  Last modified: 11/08/88     15:51
*:
*:          Calls: DEMOBILL       (procedure in LTRUTL.PRG)
*:               : DEMOINV        (procedure in LTRUTL.PRG)
*:               : SPECMENU       (procedure in LTRUTL.PRG)
*:
*:   Memory Files: COLOR.MEM
*:               : MONO.MEM
*:
*:      Documented 01/01/88 at 08:25                SNAP!  version 3.12a
*:*********************************************************************

* this is a demonstration program to show the usage of the letter
* utilities.

* all this program does is run the letter routines themselves,
* check for the presense of an activation file
* read the criteria, and transfer control to the letter printing
* procedure if the record passes
* it simulates two actions which might be performed in an actual
* application....doing a billing run on a customer file, and
* doing an invoice run on a customer file.  These simulations run
* automatically, just select-em from the menu!!!


* set up the fox program first
CLEAR
CLOSE DATABASES
RELEASE ALL
SET TALK Off
SET ESCAPE Off
SET BELL Off
SET SCOREBOARD Off
SET INTENSITY Off
SET DELETED ON
SET CONFIRM ON
SET DELIMITERS TO "[]"
SET DELIMITERS ON
SET PROCEDURE TO ltrutl            && set the procedure to the init procs
SET MESSAGE TO 24
IF ISCOLOR()                        && if running on a color monitor
   RESTORE FROM COLOR ADDITIVE      && get the color macro file
ELSE
   RESTORE FROM mono ADDITIVE       && otherwise get the monochrome macros
ENDIF

*  simulate a global file

co_name="Testing Company"
co_addr="123 Testing Street"
co_city="Demo City"
co_state="IN"
co_zip="99999-0099"
co_phone="(555) 555-1212"

DO WHILE .T.      && main loop
   CLEAR
   @00,00 TO 00,79 DOUBLE
   @22,00 TO 22,79 DOUBLE
   &vreverse
   @00,03 SAY " Letter Utility Demo "
   @22,65 SAY " [Esc] to Exit "
   &vnormal
   @02,03 PROMPT "1. Simulated Billing Run " MESSAGE "Perform a simulated billing run."
   @03,03 PROMPT "2. Simulated Invoice Run " MESSAGE "Perform a simulated invoice printing run"
   @04,03 PROMPT "3. Maintain Letter Files " MESSAGE "Maintain the letter specification files."
   @01,01 TO 05,COL()+2 DOUBLE
   MENU TO choice
   DO CASE
   CASE choice=1
      DO demobill
   CASE choice=2
      DO demoinv
   CASE choice=3
      DO specmenu
   OTHERWISE
      EXIT
   ENDCASE
ENDDO
QUIT
*: EOF: DEMO.PRG
