*:*********************************************************************
*:
*: Procedure file: LTRUTL.PRG
*:
*:         System: Foxbase Letter Utilities
*:         Author: Brian R. Toole
*:      Copyright (c) 1988, Brian R. Toole & Indiana Micrographics
*:  Last modified: 01/01/88      8:20
*:
*:  Procs & Fncts: PSELECT
*:               : MSGCENTER
*:               : SPECMENU
*:               : PRNLTR
*:               : LTRWORK
*:               : MAINTSPEC
*:               : LLETTER
*:               : SHOWSPECS
*:               : SETLTR
*:               : DEMOSET
*:               : DEMOTST1
*:               : DEMOTST2
*:               : DEMOBILL
*:               : DEMOINV
*:
*:      Documented 11/08/88 at 08:25                SNAP!  version 3.12a
*:*********************************************************************

*  compilation of a number of utilities used to print letters
*  automaticaly from a FOXBASE+ application.
*
*  These procedures are called from inside this program, and driven from
*  the 'demo' program
*
*  There are two additional memory files included and these procedures
*  require them for video control
*  the names are COLOR.MEM
*  and MONO.MEM
*  Color contains a set of video macros
*  Mono contains a set of monochrome macros.
*  They are explained further in the demo source

*  Have fun!!

*-=-=-=-=-=-=-=-=-=-=-=-=-==-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

*!*********************************************************************
*!
*!      Procedure: PSELECT
*!
*!      Called by: LTRWORK        (procedure in LTRUTL.PRG)
*!               : LLETTER        (procedure in LTRUTL.PRG)
*!               : DEMOBILL       (procedure in LTRUTL.PRG)
*!               : DEMOINV        (procedure in LTRUTL.PRG)
*!
*!*********************************************************************
PROCEDURE pselect
PARAMETERS rw,cl

*  I use this routine to set the printer port every time I do a printing
*  routine.  You dont have to use this, but I like it.
*  The parameters are
*  RW=the row to throw the box at
*  CL=the column to throw the box at
*  you might want to stick some error checking in this routine
*  to see if the printer is online & stuff!!

SAVE SCREEN TO psscrn            && save screen cause you're gonna mess it up!
@rw,cl-1 SAY "                     "
&vreverse
@rw,cl SAY " Select Output Port "
&vnormal
@rw+2,cl CLEAR TO rw+2,cl+36
@rw+2,cl PROMPT "LPT1"
@rw+2,COL()+2 PROMPT "LPT2"
@rw+2,COL()+2 PROMPT "LPT3"
@rw+2,COL()+2 PROMPT "COM1"
@rw+2,COL()+2 PROMPT "COM2"
@rw+2,COL()+2 PROMPT "FILE"
@rw+1,cl-1,rw+3,COL()+2 BOX
MENU TO choice
DO CASE
CASE choice=0 .OR.  choice=1
   SET PRINTER TO lpt1
CASE choice=2
   SET PRINTER TO lpt2
CASE choice=3
   SET PRINTER TO lpt3
CASE choice=4
   SET PRINTER TO com1
CASE choice=5
   SET PRINTER TO com2
CASE choice=6
   filena="  OUTPUT"
   @rw+5,cl CLEAR TO rw+5,cl+25
   @rw+5,cl SAY "File name? "GET filena PICTURE "!!!!!!!!"
   READ
   filena=LTRIM(TRIM(filena))+".txt"
   SET PRINT TO &filena
ENDCASE
RESTORE SCREEN FROM psscrn       && put the original screen back
RETURN

*!*********************************************************************
*!
*!      Procedure: MSGCENTER
*!
*!      Called by: PRNLTR         (procedure in LTRUTL.PRG)
*!               : LTRWORK        (procedure in LTRUTL.PRG)
*!               : MAINTSPEC      (procedure in LTRUTL.PRG)
*!               : LLETTER        (procedure in LTRUTL.PRG)
*!               : DEMOSET        (procedure in LTRUTL.PRG)
*!
*!*********************************************************************
PROCEDURE msgcenter
PARAMETERS msgtxt,msglen
* this is a short little routine I wrote to center a message inside a
* character string based on the length of the message, and the desired
* ending width of the string.  nothin' fancy, but it works!
* calling parameters: Note that this is a UDF so watch how you call it
* use like  yourmsg = msgcenter("This Message",78)
* msgtext = the text you want centered
* msglen  = the width you want it centered on
***********************************************************************
msgtxt=LTRIM(TRIM(msgtxt))           && how long is the message
IF LEN(msgtxt)>msglen                && if its bigger than the width u gave
   RETURN msgtxt                     && thats nonsense, don't do anything and
ELSE                                 && pass it back unaltered...otherwise
   pchrs=msglen-LEN(msgtxt)          && pad characters needed width-the message
   fpchars=INT(pchrs/2)              && split in half
   rmsg=SPACE(fpchars)+msgtxt+SPACE(fpchars) && stuff message between the pads
   IF LEN(rmsg)<msglen               && if we lost a character with the INT
      rmsg=rmsg+" "                  && add it on the end
   ENDIF                             && to always return the exact width requested
ENDIF
RETURN rmsg                          && send back the altered string

*!*********************************************************************
*!
*!      Procedure: SPECMENU
*!
*!      Called by: DEMO.PRG                      
*!
*!          Calls: LTRWORK        (procedure in LTRUTL.PRG)
*!               : MAINTSPEC      (procedure in LTRUTL.PRG)
*!               : LLETTER        (procedure in LTRUTL.PRG)
*!
*!*********************************************************************
PROCEDURE specmenu

*  this is the controling menu for the letter utilities
*  you can modify it to fit in your program, or call it like it is cause
*  it saves the screen config before starting, and returns it afterwords

SAVE SCREEN TO specscrn
isworking=.T.
DO WHILE isworking            && were working...do until were not!
   CLEAR                         && clear the screen
   @00,00 TO 00,79 DOUBLE        && and draw (my) standard screen
   @22,00 TO 22,79 DOUBLE        && configuration.
   &vreverse                     && turn inverse video on (see demo program)
   @00,03 SAY " Letter Specfications Menu "
   @22,65 SAY " [Esc] to Exit "
   &vnormal                      && turn inverse video off
   @02,03 PROMPT "1. Add/Edit/Delete Letters " MESSAGE "Add, edit or remove letters from the main storage file."
   @03,03 PROMPT "2. Activate/Deactivate     " MESSAGE "Activate or deactivate letter specifications used in this program."
   @04,03 PROMPT "3. Live Letter Run         " MESSAGE "Print letters directly from the datafile."
   @01,01 TO 05,COL()+2 DOUBLE
   MENU TO choice
   DO CASE
   CASE choice=1                       && if user selects item 1
      DO ltrwork                       && go to the letter editing procedure
   CASE choice=2                       && if the user selects item 2
      DO maintspec WITH "demo.mem","demoset"           && go to the activation procedure
   CASE choice=3                       && if the user selects item 3
      DO lletter                    && go to the live printing procedure
   OTHERWISE
      isworking=.F.                    && were done, exit the loop
   ENDCASE
ENDDO
RESTORE SCREEN FROM specscrn
RETURN

* This is the routine which does the actual letter printing
* It assumes several things...
*  1. That the file which contains the name and address is selected with an
*     alias of main.
*  2. that the following fields are present:
*      a)    LNAME=recipients last name
*      b)    FNAME=recipients first name
*      c)    INIT =recipients initial if any
*      d)    TITLE=character variable to indicate
*               'M'= Use "Mr."
*               'F'= Use "Mrs."
*               'S'= Use "Miss"
*      e)    ADDR=recipients street address
*      f)    CITY=recipients city
*      g)    STATE=recipients state
*      h)    ZIP=recipients zip code
*  3. That if you want the company name printed as a header the following
*     memory variables are present:
*        a) co_name  =  company name
*        b) co_addr  =  company address
*        c) co_city  =  company city
*        d) co_state =  company state
*        e) co_zip   =  company zip
*        f) co_phone =  company phone
*     I keep these in a global memory variable file that is created when the
*     program is run the first time along with other global values, and they
*     are restored during program initialization.  The demo program has these
*     hard coded in the set up routine.
*  4. That the letter.dbf file is open in an alternate work area and has
*     an alias of letter.
*---------------------------------------------------------------------------

*!*********************************************************************
*!
*!      Procedure: PRNLTR
*!
*!      Called by: LLETTER        (procedure in LTRUTL.PRG)
*!               : DEMOTST2       (procedure in LTRUTL.PRG)
*!
*!          Calls: MSGCENTER      (procedure in LTRUTL.PRG)
*!
*!*********************************************************************
PROCEDURE prnltr
SET DEVICE TO PRINT
SET PRINT ON
SET CONSOLE Off
*  compute the body width as follows
*  assume page is 80 characters wide
*  subtract 2 times the left margin to center
*  the text on the page
lstart = letter->l_margin
pgwid  = 80-(2*lstart)
SET MEMOWIDTH TO pgwid                      && set the memo width to the page size
IF letter->header                           && if the flag to print the header is on
   msg=msgcenter(co_name,pgwid)  && print the header information
   @02,lstart SAY msg
   msg=msgcenter(co_addr,pgwid)
   @03,lstart SAY msg
   msg=msgcenter(TRIM(co_city)+", "+co_state+" "+co_zip,pgwid)
   @04,lstart SAY msg
   msg=msgcenter(co_phone,pgwid)
   @05,lstart SAY msg
ENDIF
DO CASE                                     && determine the appropriate title
CASE TITLE="F"
   rtitle="Mrs. "
CASE TITLE="S"
   rtitle="Miss "
OTHERWISE                                && default to a "Mr." even if blank
   rtitle="Mr. "
ENDCASE
@letter->start_addr,lstart SAY rtitle
@PROW(),Pcol() SAY TRIM(fname)+" "+TRIM(init)+" "+TRIM(lname)
@PROW(),62 SAY DTOC(DATE())
@PROW()+1,lstart SAY TRIM(addr)
@PROW()+1,lstart SAY TRIM(city)+" "+state+"    "+TRIM(zip)
@letter->start_body,lstart SAY "Dear "+rtitle+TRIM(lname)
SELECT letter
@PROW()+2,lstart
?? page1
IF no_pages=1
   @PROW()+4,lstart SAY sig_nam
   @PROW()+1,lstart SAY sig_title
ENDIF
IF number
   pg=msgcenter("Page 1",pgwid)
   @60,lstart SAY pg
ENDIF
IF no_pages>1
   EJECT
   @start_addr,lstart
   ?? page2
   IF no_pages=2
      @PROW()+4,lstart SAY sig_nam
      @PROW()+1,lstart SAY sig_title
   ENDIF
   IF number
      pg=msgcenter("Page 2",pgwid)
      @60,lstart SAY pg
   ENDIF
ENDIF
IF no_pages>2
   EJECT
   @start_addr,lstart
   ?? page3
   IF no_pages=3
      @PROW()+4,lstart SAY sig_nam
      @PROW()+1,lstart SAY sig_title
   ENDIF
   IF number
      pg=msgcenter("Page 3",pgwid)
      @60,lstart SAY pg
   ENDIF
ENDIF
IF no_pages>3
   EJECT
   @start_addr,lstart
   ?? page4
   IF no_pages=4
      @PROW()+4,lstart SAY sig_nam
      @PROW()+1,lstart SAY sig_title
   ENDIF
   IF number
      pg=msgcenter("Page 4",pgwid)
      @60,lstart SAY pg
   ENDIF
ENDIF
IF no_pages>4
   EJECT
   @start_addr,lstart
   ?? page5
   @PROW()+4,lstart SAY sig_nam             && last page by design...have to
   @PROW()+1,lstart SAY sig_title            && print the signature on this page
   IF number
      pg=msgcenter("Page 5",pgwid)
      @60,lstart SAY pg
   ENDIF
ENDIF
EJECT
SET CONSOLE Off
SET DEVICE TO SCREEN
SET PRINT Off
SET MEMOWIDTH TO 50
SELECT main                                  && reselect the original datafile
RETURN


*!*********************************************************************
*!
*!      Procedure: LTRWORK
*!
*!      Called by: SPECMENU       (procedure in LTRUTL.PRG)
*!
*!          Calls: SETLTR         (procedure in LTRUTL.PRG)
*!               : PSELECT        (procedure in LTRUTL.PRG)
*!               : MSGCENTER      (procedure in LTRUTL.PRG)
*!               : @PROW()        (function  in ?)
*!
*!           Uses: LETTER.DBF         Alias: LETTER
*!
*!        Indexes: LETTER.IDX
*!
*!*********************************************************************
PROCEDURE ltrwork
* this is the routine which controls the creation and editing of the actual
* letter files.
* there are several areas where this procedure could be improved, but I haven't
* had time to fix it up yet.
* the first probable sticking point is the selection of the title
* if you run over the screen it will crash, so this leaves about 120 letter titles
* which can be displayed on the screen.  A routine to add one or more pages to
* this display is in the works if I can find time to finish it.  My users have
* never had more than 30 letters in over 16 months, so it has a *low* priority at
* this point.
*
USE letter INDEX letter ALIAS letter                  && open the letter file
tval=RECCOUNT()                                       && count number in file
DIMENSION exltr((tval+1))                             && set up an array to hold titles
GOTO TOP                                              &&
psn=1                                                 &&
DO WHILE .NOT. EOF()                                  && fill the array with
   psns=LTRIM(STR(psn,2))                             && the titles of
   exltr(&psns)=TITLE                                 && the letters
   psn=psn+1
   SKIP
ENDDO
CLEAR                                                 && set up the screen
@00,00 TO 00,79 DOUBLE                                &&
@22,00 TO 22,79 DOUBLE                                &&
@01,03 SAY " Existing Specifications "                &&
IF tval=0                                             &&
   @02,01,04,78 BOX                                   && if there were no titles
   @03,03 SAY "No Current Specifications"             && in the file, say so
   rw=4                                               &&
ELSE                                                  &&
   tval1=1                                            &&  otherwise start
   rw=03                                              &&  painting the 10 char
   cl=03                                              &&  titles in prompts on
   clp=01                                             &&  the screen
   DO WHILE tval1<=tval                               &&  rw=row
      tvs=LTRIM(STR(tval1,2))                         &&  cl=column
      @rw,cl PROMPT exltr(&tvs)                       &&  clp=counter to track
      clp=clp+1                                       &&      how many on each row
      cl=cl+12                                        &&  put 2 spaces between each
      tval1=tval1+1                                   &&  increment to next
      IF clp=8                                        &&  if 7 on the row (clp-1)
         cl=03                                        &&  reset the counters
         clp=1                                        &&  and go to the
         rw=rw+1                                      &&  next row on the screen
      ENDIF                                           &&  exits when all in the
   ENDDO                                              &&  array are up
   @02,01,rw+1,78 BOX                                 &&  draw a box around em
ENDIF                                                 &&
@rw+3,02 PROMPT "Create New"                          &&  choice to add a new one
MENU TO choice                                        &&  well...what to do?
IF choice=0                                           &&  hey...[Esc] pushed
   CLOSE DATA                                         &&  we're done
   RETURN                                             &&  go back
ENDIF                                                 &&
IF choice>tval                                        &&  if the choice is
   nwlet=.T.                                          &&  greater than the array
ELSE                                                  &&  it was 'create new'
   chval=LTRIM(STR(choice,2))                         &&  set a flag, otherwise
   skval=exltr(&chval)                                &&  grab the letter title
   SEEK skval                                         &&  from the array and set
   nwlet=.F.                                          &&  the file at that record
ENDIF                                                 &&  and drop the new flag
SCATTER TO lt                                         &&  set an array for the file
IF nwlet                                              &&  if its a 'create new'
   lt(1)=SPACE(10)                                            &&  initialize the array
   lt(2)=10                                           &&
   lt(4)=5
   lt(3)=18                                           &&
   lt(5)=1                                            &&
   lt(6)=.T.
ENDIF                                                 &&
DO setltr                                             &&  paint screen and get
@23,00 CLEAR TO 24,79                                 &&  the information
READ                                                  &&
IF READKEY()>36                                       &&  if changes were made
   IF nwlet                                           &&     and it's a new one
      @23,00 PROMPT "Save"                            &&     ask if its ok to save
      @23,COL()+2 PROMPT "Abandon"                    &&     or throw it out
      MENU TO choice                                  &&     well??
      IF choice=1                                     &&     Yep save it
         APPEND BLANK                                 &&     by adding a blank
         GATHER FROM lt                               &&     and flushing the array
      ELSE                                            &&   otherwise
         CLOSE DATA                                   &&      go back
         RETURN                                       &&      could be modified to loop
      ENDIF                                           &&   -or-
   ELSE                                               &&   if it was an edit
      @23,00 PROMPT "Save Changes"                    &&   do we want the
      @23,COL()+2 PROMPT "Abandon Changes"            &&   changes or not???
      MENU TO choice                                  &&   well???
      IF choice=1                                     &&   yea, save it
         GATHER FROM lt                               &&   by flushing the array
      ELSE                                            &&   or toss it by
         SCATTER TO lt                                &&   resetting the array
      ENDIF                                           &&
   ENDIF                                              &&
ENDIF                                                 &&
SAVE SCREEN TO tscrn1                                 &&   grab a copy of the screen
DO WHILE .T.                                          &&   start a loop
   @23,00 CLEAR TO 24,79                              &&
   @23,00 PROMPT "Done"                               &&   finished??
   @23,COL()+2 PROMPT "Align"                         &&   test letter alingnment?
   @23,COL()+2 PROMPT "1.Page 1"                     &&   edit each page
   IF lt(5)>=2                                        &&         
      @23,COL()+2 PROMPT "2.Page 2"                  &&   based on if its
   ENDIF                                              &&   specified or not
   IF lt(5)>=3                                        &&
      @23,COL()+2 PROMPT "3.Page 3"                  &&
   ENDIF                                              &&
   IF lt(5)>=4                                        &&
      @23,COL()+2 PROMPT "4.Page 4"                  &&
   ENDIF                                              &&
   IF lt(5)=5                                         &&
      @23,COL()+2 PROMPT "5.Page 5"                  &&
   ENDIF                                              &&
   MENU TO choice                                     &&
   DO CASE                                            &&
   CASE choice=2  && align                            &&  alignment test
      DO pselect WITH 10,10                           &&  puts full field widths
      RESTORE SCREEN FROM tscrn1                      &&  of information
      @23,00 CLEAR TO 24,79                           &&  where needed
      &vblink                                         &&
      @23,00 SAY "Printing..."                        &&  see the prnltr
      &vnormal                                        &&  procedure for more
      SET DEVICE TO PRINT                             &&  info
      SET PRINT ON                                    &&
      SET CONSOLE Off                                 &&
      pgwid=80-(2*l_margin)                            &&
      lstart=l_margin                                  &&
      SET MEMOWIDTH TO pgwid                          &&
      @01,lstart SAY "<"+REPLICATE("-",(pgwid-2))+">"  &&
      IF Header                                       &&   if there's a header
         msg=msgcenter("XXXXXXXXXXXXXXXXXXXXXXXXX",pgwid)
         @02,lstart SAY msg
         msg=msgcenter("XXXXXXXXXXXXXXXXXXXXXXXXX",pgwid)
         @03,lstart SAY msg
         msg=msgcenter("XXXXXXXXXXXXXXXXXXXX, XX  XXXXX-XXXX",pgwid)
         @04,lstart SAY msg
         msg=msgcenter("(XXX) XXX-XXXX",pgwid)
         @05,lstart SAY msg
      ENDIF
      @start_addr,lstart SAY "XXXX XXXXXXXXXXXXXXX X. XXXXXXXXXXXXXXX"
      @PROW(),62 SAY DTOC(co_last)
      @PROW()+1,lstart SAY "XXXXXXXXXXXXXXXXXXXXXXXXX"
      @PROW()+1,lstart SAY "XXXXXXXXXXXXXXXXXXXX, XX    XXXXX-XXXX"
      @start_body,lstart SAY "Dear XXXX XXXXXXXXXXXXXXX"
      @PROW()+2,lstart
      ?? page1
      IF no_pages=1
         @PROW()+4,lstart SAY sig_nam
         @PROW()+1,lstart SAY sig_title
      ENDIF
      IF number
         pg=msgcenter("Page 1",pgwid)
         @60,lstart SAY pg
      ENDIF
      IF no_pages>1
         EJECT
         @start_addr,lstart
         ?? page2
         IF no_pages=2
            @PROW()+4,lstart SAY sig_nam
            @PROW()+1,lstart SAY sig_title
         ENDIF
         IF number
            pg=msgcenter("Page 2",pgwid)
            @60,lstart SAY pg
         ENDIF
      ENDIF
      IF no_pages>2
         EJECT
         @start_addr,lstart
         ?? page3
         IF no_pages=3
            @PROW()+4,lstart SAY sig_nam
            @PROW()+1,lstart SAY sig_title
         ENDIF
         IF number
            pg=msgcenter("Page 3",pgwid)
            @60,lstart SAY pg
         ENDIF
      ENDIF
      IF no_pages>3
         EJECT
         @start_addr,lstart
         ?? page4
         IF no_pages=4
            @PROW()+4,lstart SAY sig_nam
            @PROW()+1,lstart SAY sig_title
         ENDIF
         IF number
            pg=msgcenter("Page 4",pgwid)
            @60,lstart SAY pg
         ENDIF
      ENDIF
      IF no_pages>4
         EJECT
         @start_addr,lstart
         ?? page5
         @PROW()+4,lstart SAY sig_nam             && last page by design...have to
         @PROW()+1,lstart SAY sig_title            && print the signature on this page
         IF number
            pg=msgcenter("Page 5",pgwid)
            @60,lstart SAY pg
         ENDIF
      ENDIF
      EJECT
      SET CONSOLE Off
      SET DEVICE TO SCREEN
      SET PRINT Off
   CASE choice=3                                     && pretty self
      EDIT FIELD page1                               && explanitory
   CASE choice=4                                     && editing of the
      EDIT FIELD page2                               && memo fields
   CASE choice=5
      EDIT FIELD page3
   CASE choice=6
      EDIT FIELD page4
   CASE choice=7
      EDIT FIELD page5
   OTHERWISE
      CLOSE DATA
      RETURN
   ENDCASE
   RESTORE SCREEN FROM tscrn1
ENDDO
CLOSE DATA
RETURN

*!*********************************************************************
*!
*!      Procedure: MAINTSPEC
*!
*!      Called by: SPECMENU       (procedure in LTRUTL.PRG)
*!
*!          Calls: SHOWSPECS      (procedure in LTRUTL.PRG)
*!               : MSGCENTER      (procedure in LTRUTL.PRG)
*!               : &CRITPROC
*!
*!           Uses: LETTER.DBF         Alias: LETTER
*!
*!        Indexes: LETTER.IDX
*!
*!   Memory Files: &MFILENA
*!
*!*********************************************************************
PROCEDURE maintspec
PARAMETERS mfilena,critproc
*
* mfilena = the name of the activation memory file
* critproc = the name of the procedure file used to set the criteria
*
* the procedures you use to activate the specification varies with
* each application and where you would like to trigger the letters to
* be printed from.  Each application is case specific, but the principle
* is all the same.  For the purposes of the demo program we only
* have one activation file but you can use as many as you want
* simply by calling this routine with a different memory file name
* and criteria procedure name.
*
USE letter INDEX letter
IF .NOT. File("&mfilena")     && if the memory file doesn't exist, make it
   psn=1                      && psn marks the position in the file
   DO WHILE psn<=20              && make 20 possible variables
      psns=LTRIM(STR(psn,2))     && work up a string to tack on the end
      ltr_ttl&psns=SPACE(10)   && letter title
      ltr_trn&psns=0             && using trigger number
      ltr_trfn&psns=SPACE(10)    && trigger field name
      ltr_trl&psns=SPACE(15)     && trigger low value
      ltr_trh&psns=SPACE(15)     && trigger high value
      ltr_np&psns=0              && number of times activated  (printed)
      psn=psn+1                  && increment the position counter
   ENDDO                      && exit when psn=21
   ltr_create=DATE()          && file created on (date)
   ltr_mod=DATE()             && date of last modification
   ltr_total=0                && number currently active
   SAVE TO &mfilena ALL LIKE ltr_*        && make the file
ELSE
   RESTORE FROM &mfilena ADDITIVE       && restore from the file
ENDIF
isworking=.T.                 && set up the working flag
PUBLIC ischanged                 && flag to show if any changes were made to the
*                                activation file
DO WHILE isworking            && start the loop
   CLEAR                         &&
   DO showspecs                  && show the currently active specifications
   @22,00 TO 22,79 DOUBLE
   @23,00 PROMPT "Add" MESSAGE "Add a letter to the activation list."
   @23,COL()+2 PROMPT "Edit" MESSAGE "Edit a letter on the activation list."
   @23,COL()+2 PROMPT "Delete" MESSAGE "Delete a letter from the activation list."
   @23,COL()+2 PROMPT "Quit" MESSAGE "Leave this function and return to the specifications menu."
   MENU TO choice
   DO CASE
   CASE choice=1     && add
      IF ltr_total=20
         ??CHR(7)
         @23,00 CLEAR TO 24,79
         &vreverse
         msg=msgcenter("Only 20 specifications allowed active at one time",79)
         @23,00 SAY msg
         &vnormal
         @23,00
         WAIT
         LOOP
      ENDIF
      DO &critproc WITH "0"     && 0 indicates to add spec  (note its a character)
   CASE choice=2     && edit
      @23,00 CLEAR TO 24,79
      lspecno=SPACE(2)
      @23,00 SAY "Edit Specification Number " GET lspecno PICTURE "99"
      READ
      tstr=LTRIM(lspecno)
      IF LEN(TRIM(ltr_ttl&tstr))=0      && no title, not active!
         @23,00 CLEAR TO 24,79
         &vreverse
         msg=msgcenter("That Specification is not active !",79)
         @23,00 SAY msg
         &vnormal
         ?? CHR(7)
         @23,00
         WAIT
         LOOP
      ENDIF
      DO &critproc WITH TRIM(lspecno)
   CASE choice=3
      @23,00 CLEAR TO 24,79
      lspecno=SPACE(2)
      @23,00 SAY "Delete Specification Number " GET lspecno PICTURE "99"
      READ
      tstr=LTRIM(lspecno)
      IF LEN(TRIM(ltr_ttl&tstr))=0      && no title, not active!
         @23,00 CLEAR TO 24,79
         &vreverse
         msg=msgcenter("That Specification is not active !",79)
         @23,00 SAY msg
         &vnormal
         ?? CHR(7)
         @23,00
         WAIT
         LOOP
      ENDIF
      @23,00 SAY "Are You Sure ? "
      @23,COL() PROMPT "No"
      @23,COL()+2 PROMPT "Yes"
      MENU TO choice
      IF choice=2
         ltr_ttl&tstr=SPACE(10)   && letter title
         ltr_trn&tstr=0             && using trigger number
         ltr_trfn&tstr=SPACE(10)    && trigger field name
         ltr_trl&tstr=SPACE(15)     && trigger low value
         ltr_trh&tstr=SPACE(15)     && trigger high value
         ltr_np&tstr=0              && number of times activated  (printed)
         ltr_total=ltr_total-1
         ischanged=.T.
      ENDIF
   OTHERWISE
      isworking=.F.
   ENDCASE
ENDDO
DO WHILE ischanged
   @23,00 CLEAR TO 24,79
   @23,00 PROMPT "Save Changes"
   @23,COL()+2 PROMPT "Abandon Changes"
   MENU TO choice
   DO CASE
   CASE choice=1
      SAVE TO &mfilena ALL LIKE ltr_*
      ischanged=.F.
   CASE choice=2
      @23,00 CLEAR TO 24,79
      @23,00 SAY "Are you sure ? "
      @23,COL() PROMPT "No"
      @23,COL()+2 PROMPT "Yes"
      MENU TO choice
      IF choice=2
         ischanged=.F.
      ENDIF
   ENDCASE
ENDDO
RETURN




*!*********************************************************************
*!
*!      Procedure: LLETTER
*!
*!      Called by: SPECMENU       (procedure in LTRUTL.PRG)
*!
*!         Calls : MSGCENTER      (procedure in LTRUTL.PRG)
*!               : PSELECT        (procedure in LTRUTL.PRG)
*!               : PRNLTR         (procedure in LTRUTL.PRG)
*!
*!           Uses: DEMO.DBF           Alias: MAIN
*!               : LETTER.DBF         Alias: LETTER
*!
*!        Indexes: DEMO.IDX
*!               : LETTER.IDX
*!
*!*********************************************************************
PROCEDURE lletter

*  this routine is used to print letters directly from your main database
*  you must substitute your own file names and criteria etc.

SELECT A
USE demo INDEX demo ALIAS main
SELECT B
USE letter INDEX letter
DO WHILE isworking
   CLEAR
   @00,00 TO 00,79
   @22,00 TO 22,79
   &vreverse
   @00,03 SAY " Print Letters "
   @22,65 SAY " [Esc] to exit "
   &vnormal
   temptitle=SPACE(10)
   @02,03 SAY "Print the letter titled " GET temptitle PICTURE "!!!!!!!!!!"
   READ
   IF READKEY()<=36
      EXIT
   ENDIF
   SELECT letter
   SEEK temptitle
   IF .NOT. FOUND()
      ??CHR(7)
      &vreverse
      msg=msgcenter("That title isn't in the files",79)
      @03,00 SAY msg
      &vnormal
      @04,00
      WAIT
      LOOP
   ENDIF
   
   
   *  at this point you need to place in your own selection criteria code.
   *  for the demo program, we'll just use the last name for simplicity
   
   tval1=SPACE(15)
   tval2="zzzzzzzzzzzzzzz"
   @03,03 SAY "Low  Last Name " GET tval1 PICTURE "!XXXXXXXXXXXXXX"
   @04,03 SAY "High Last Name " GET tval2 PICTURE "!XXXXXXXXXXXXXX"
   READ
   SELECT main
   COUNT ALL FOR lname>=tval1 .AND. lname<=tval2 TO tcnt
   @05,03 SAY "There are "+LTRIM(STR(tcnt,4))+" names that match the criteria."
   @23,00 PROMPT "Continue"
   @23,COL()+2 PROMPT "Abort"
   MENU TO choice
   IF choice=2 .OR. choice=0
      EXIT
   ENDIF
   @23,00 CLEAR TO 24,79
   @23,00 SAY "Working..."
   LOCATE ALL FOR lname>=tval1 .AND. lname<=tval2
   @23,00 CLEAR TO 24,79
   DO pselect WITH 10,10
   @23,00 PROMPT "Print"
   @23,COL()+2 PROMPT "Abort"
   MENU TO choice
   IF choice=2 .OR. choice=0
      EXIT
   ENDIF
   @23,00 CLEAR TO 24,79
   @23,00 SAY "Printing..."
   DO WHILE .NOT. EOF(1)
      DO prnltr
      SELECT main
      CONTINUE
   ENDDO
ENDDO
CLOSE DATA
RETURN


*!*********************************************************************
*!
*!      Procedure: SHOWSPECS
*!
*!      Called by: MAINTSPEC      (procedure in LTRUTL.PRG)
*!
*!*********************************************************************
PROCEDURE showspecs
*  this is pretty straightforward display code that shows what the
*  current contents of the loaded activation file is...
@0,0 CLEAR TO 22,79
&vreverse
@1,27 SAY " Letter Activation File "
@3,1 SAY " #  "
@3,6 SAY " Letter      "
@3,20 SAY "  Activation Field "
@3,40 SAY " # "
@3,44 SAY "  Letter      "
@3,59 SAY " Activation Field   "
@16,4 SAY " Used  "
@16,16 SAY " Used  "
@16,28 SAY " Used  "
@16,40 SAY " Used  "
@16,52 SAY " Used  "
@16,60 SAY " Misc. Information "
&vnormal
@1,56 SAY "Created"
@2,1 SAY ""
@3,5 SAY ""
@3,19 SAY ""
@3,39 SAY ""
@3,43 SAY ""
@3,58 SAY ""
@4,1 SAY ""
@5,2 SAY "1                                   11              "
@6,2 SAY "2                                   12              "
@7,2 SAY "3                                   13              "
@8,2 SAY "4                                   14              "
@9,2 SAY "5                                   15              "
@10,2 SAY "6                                   16              "
@11,2 SAY "7                                   17              "
@12,2 SAY "8                                   18              "
@13,2 SAY "9                                   19              "
@14,2 SAY "10                                  20              "
@15,1 SAY ""
@16,1 SAY "# "
@16,11 SAY " # "
@16,23 SAY " # "
@16,35 SAY " # "
@16,47 SAY " # "
@16,59 SAY ""
@17,1 SAY ""
@18,1 SAY "1         5         9        13        17         Last"
@19,1 SAY "2         6        10        14        18         Modified"
@20,1 SAY "3         7        11        15        19         Total"
@21,1 SAY "4         8        12        16        20         Active"
@0,0 TO 22,79
@0,0 SAY CHR(213)+REPLICATE(CHR(205),78)+CHR(184)
@22,0 SAY CHR(212)+REPLICATE(CHR(205),78)+CHR(190)
@1,2 SAY co_name
@1,64 SAY DTOC(ltr_created)
@5,7 SAY ltr_ttl1
@5,24 SAY ltr_trfn1
@5,46 SAY ltr_ttl11
@5,64 SAY ltr_trfn11
@6,7 SAY ltr_ttl2
@6,24 SAY ltr_trfn2
@6,46 SAY ltr_ttl12
@6,64 SAY ltr_trfn12
@7,7 SAY ltr_ttl3
@7,24 SAY ltr_trfn3
@7,46 SAY ltr_ttl13
@7,64 SAY ltr_trfn13
@8,7 SAY ltr_ttl4
@8,24 SAY ltr_trfn4
@8,46 SAY ltr_ttl14
@8,64 SAY ltr_trfn14
@9,7 SAY ltr_ttl5
@9,24 SAY ltr_trfn5
@9,46 SAY ltr_ttl15
@9,64 SAY ltr_trfn15
@10,7 SAY ltr_ttl6
@10,24 SAY ltr_trfn6
@10,46 SAY ltr_ttl16
@10,64 SAY ltr_trfn16
@11,7 SAY ltr_ttl7
@11,24 SAY ltr_trfn7
@11,46 SAY ltr_ttl17
@14,64 SAY ltr_trfn20
@13,64 SAY ltr_trfn19
@12,7 SAY ltr_ttl8
@12,24 SAY ltr_trfn8
@12,46 SAY ltr_ttl18
@13,7 SAY ltr_ttl9
@13,24 SAY ltr_trfn9
@13,46 SAY ltr_ttl19
@14,7 SAY ltr_ttl10
@14,24 SAY ltr_trfn10
@14,46 SAY ltr_ttl20
@18,6 SAY STR(ltr_np1,4)
@18,18 SAY STR(ltr_np5,4)
@18,30 SAY STR(ltr_np9,4)
@18,42 SAY STR(ltr_np13,4)
@18,53 SAY STR(ltr_np17,4)
@19,6 SAY STR(ltr_np2,4)
@19,18 SAY STR(ltr_np6,4)
@19,30 SAY STR(ltr_np10,4)
@19,42 SAY STR(ltr_np14,4)
@19,53 SAY STR(ltr_np18,4)
@19,70 SAY DTOC(ltr_mod)
@20,6 SAY STR(ltr_np3,4)
@20,18 SAY STR(ltr_np7,4)
@20,30 SAY STR(ltr_np11,4)
@20,42 SAY STR(ltr_np15,4)
@20,53 SAY STR(ltr_np19,4)
@21,6 SAY STR(ltr_np4,4)
@21,18 SAY STR(ltr_np8,4)
@21,30 SAY STR(ltr_np12,4)
@21,42 SAY STR(ltr_np16,4)
@21,53 SAY STR(ltr_np20,4)
@21,70 SAY STR(ltr_total,4)
RETURN

*!*********************************************************************
*!
*!      Procedure: SETLTR
*!
*!      Called by: LTRWORK        (procedure in LTRUTL.PRG)
*!
*!
*!*********************************************************************
PROCEDURE setltr
* this procedure sets up the gets and screen to add or edit a
* letter in the letter file...pretty straightforward stuff
@0,0 CLEAR TO 10,79
&vreverse
@1,53 SAY " Letter File Information "
&vnormal
@2,1 SAY ""
@3,2 SAY "Title                              Signature"
@4,2 SAY "Left Margin                        Signature"
@5,2 SAY "Start Address at row               Title"
@6,2 SAY "Start Body at row                 "
@7,2 SAY "Print Company Header ?             Letter"
@8,2 SAY "Number Each Page ?                 Description"
@9,2 SAY "Total Number of Pages ?           "
@0,0 TO 10,79
@0,0 SAY CHR(213)+REPLICATE(CHR(205),78)+CHR(184)
@10,0 SAY CHR(212)+REPLICATE(CHR(205),78)+CHR(190)
@1,2 SAY co_name
@3,9 GET lt(1) PICTURE "!!!!!!!!!!"
@3,49 GET lt(8)
@4,27 GET lt(4) PICTURE "99" RANGE 1,30
@5,27 GET lt(2) PICTURE "99" RANGE 5,25
@5,49 GET lt(9)
@6,27 GET lt(3) PICTURE "99" RANGE 10,40
@7,28 GET lt(7) PICTURE "Y"
@7,51 GET lt(10)
@8,28 GET lt(6) PICTURE "Y"
@8,51 GET lt(11)
@9,28 GET lt(5) PICTURE "9" RANGE 1,5
@9,51 GET lt(12)
RETURN






*-------------------------demo specific simulations----------------------------

* sample criteria setting procedure
* to show how to set the fields in the activation file

*!*********************************************************************
*!
*!      Procedure: DEMOSET
*!
*!        Calls  : MSGCENTER      (procedure in LTRUTL.PRG)
*!
*!*********************************************************************
PROCEDURE demoset
PARAMETERS actype
IF actype="0"       && we are adding a specification...find a blank one
   edisp=.F.        && set the editing flag off
   psn=1            && temporary position counter
   spcno="0"        && initialize the specification number variable
   DO WHILE psn<=20                 && start the loop
      psns=LTRIM(STR(psn,2))        && initialize the position macro
      IF LEN(TRIM(ltr_ttl&psns))=0  && title is blank, use this one
         spcno=psns                 && set it up
         psn=20                     && bump the counter to fall out
      ENDIF                         && otherwise
      psn=psn+1                     && bump the counter and loop
   ENDDO
   IF spcno="0"                     && extra error trap-loop didn't find
      RETURN                        && a blank title
   ENDIF                            && return
ELSE
   edisp=.T.                        && raise the editing flag
   spcno=actype                     && transfer the letter number
ENDIF


* this is a sample critera procedure used to set the activation criteria for
* each activation file.  You need to create a separate procedure for each
* different activation file you wish to create if the criteria such as field
* names & such are different, If you don't need to, then you can use one
* standard procedure to set the field names and values throughout your
* program

* the demo program uses two very simple criteria, and two selection points
* in the program.

* the demo program trip can be activated either a 'billing' run (1)
* or an 'invoice' run (2)

* in your program you must determint the point at which you wish to pipe
* the name and address into a letter, and set a testing code loop there.
* you don't necessarily have to use the ltr_trn* field, but if you need
* to trap for letters at several points in a given 'area' of coding, it's
* a little easier to check for the one memory file at one location.

* you can just as easily create different memory file names for each point,
* and ignore the trigger number field...its your choice, depending on the
* particular type of code you are integrating these routines into.  I used
* them in the demo program just to show their use.

* I use prompts to enter field names and such so that the operator does'nt
* have to remember them, and because it makes error trapping much simpler
* when *you* control *exactly* what goes into the variables.  If you prefer
* to let your users enter field names themselves it would be relativley
* simple to modify the code to do that.
*
* I try to keep the input and output on the bottom two lines of the screen
* as much as possible, but in order to show editing values, you need to
* go up on the main screen

* you can modify the program to display all of the information on one
* screen by limiting your users to 10 items at once, or by paging the
* display 10 at a time.  I have not included this code in this package.

@23,00 CLEAR TO 24,79
issetting=.T.
DO WHILE issetting
   &vreverse
   @22,65 SAY " [Esc] to Exit "
   &vnormal
   @23,00 SAY "Activation Point - "
   psn=COL()
   @23,COL()+15 SAY "- - to change, to accept"
   @23,psn PROMPT "Billing Run "  MESSAGE "Print letter when processing monthly billing."
   @23,psn PROMPT "Invoice Run "  MESSAGE "Print letter when processing an customer invoice run."
   
   *  you can substitute your own points here, or code around the activation
   *  point altogether if you don't want to use them by leaving it 0 or setting it
   *  to a specific number
   *  if you do, move the escape point to somewhere else so you dont trap your user!
   
   MENU TO choice
   IF choice=0
      EXIT
   ENDIF
   ltr_trn&spcno=choice
   @22,00 TO 22,79 DOUBLE
   @23,00 CLEAR TO 24,79
   settitle=.T.
   DO WHILE settitle
      IF edisp
         temptitle=ltr_ttl&spcno
      ELSE
         temptitle=SPACE(10)
      ENDIF
      @23,00 CLEAR TO 24,79
      @23,00 SAY "Letter Title " GET temptitle PICTURE "!!!!!!!!!!"
      READ
      IF READKEY()<=36 .AND. .NOT. edisp
         EXIT
      ENDIF
      SELECT letter
      SEEK temptitle
      IF .NOT. FOUND()
         @23,00 CLEAR TO 24,79
         ??CHR(7)
         &vreverse
         msg=msgcenter("That title is not in the letters file",79)
         @23,00 SAY msg
         &vnormal
         WAIT
         LOOP
      ELSE
         ltr_ttl&spcno=temptitle
         settitle=.F.
      ENDIF
   ENDDO
   IF settitle
      LOOP
   ENDIF
   @23,00 CLEAR TO 24,79
   @23,00 SAY "Select Criteria - "
   psn=COL()
   @23,psn PROMPT "All            " MESSAGE "Print letter to all names."
   @23,psn PROMPT "Total Amount   " MESSAGE "Print letters to names with total amount between..."
   @23,psn PROMPT "Zip Code       " MESSAGE "Print letters to names with zip codes between..."
   IF edisp     && if editing, show the current values
      SAVE SCREEN TO tscrn
      @12,01 CLEAR TO 13,78
      IF ltr_trfn&spcno<>"AMOUNT"
         @12,02 SAY "Currently set for "+ltr_trfn&spcno+" between "+ltr_trl&spcno+" and "+ltr_trh&spcno
      ELSE
         @12,02 SAY "Currently set fro "+ltr_trfn&spcno+" between "+LTRIM(STR(ltr_trl&spcno,10,2))+" and "+LTRIM(STR(ltr_trh&spcno,10,2))
      ENDIF
      @11,01 TO 13,78 DOUBLE
   ENDIF
   *  you can add any number of criteria at this point, based on specific
   *  conditions you have in *your* applications
   MENU TO choice
   alln=.F.
   DO CASE
   CASE choice=1
      ltr_trfn&spcno="All Names"
      alln=.T.
   CASE choice=2
      ltr_trfn&spcno="AMOUNT"
      ltr_trl&spcno=0
      ltr_trh&spcno=0
      tempic="'999999.99'"                && note the double quotes!!
   CASE choice=3
      ltr_trfn&spcno="ZIP"
      ltr_trl&spcno=SPACE(11)
      ltr_trh&spcno=SPACE(11)
      tempic="'99999-9999'"
   OTHERWISE
      LOOP
   ENDCASE
   IF .NOT. alln                                       && if not all of the names
      DO CASE                               && then get the values
      CASE choice=2                         && for the range involved
         ttxt="Total Amount "
      OTHERWISE
         ttxt="Zip Code "
      ENDCASE
      @23,00 CLEAR TO 24,79
      @23,00 SAY "Low  "+ttxt GET ltr_trl&spcno PICTURE &tempic
      @24,00 SAY "High "+ttxt GET ltr_trh&spcno PICTURE &tempic
      READ
   ENDIF
   IF edisp
      RESTORE SCREEN FROM tscrn
   ENDIF
   @23,00 CLEAR TO 24,79
   @23,00 PROMPT "Ok" MESSAGE "Information correct as entered."
   @23,COL()+2 PROMPT "Redo" MESSAGE "Re-enter the information."
   MENU TO choice
   IF choice=1
      issetting=.F.
      IF .NOT. edisp               && if we're not editing
         ltr_total=ltr_total+1     && bump up the letter total
      ENDIF                        && otherwise leave it
      ischanged=.T.
   ENDIF
ENDDO
@23,00 CLEAR TO 24,79
RETURN


*!*********************************************************************
*!
*!      Procedure: DEMOTST1
*!
*!      Called by: DEMOBILL       (procedure in LTRUTL.PRG)
*!               : DEMOINV        (procedure in LTRUTL.PRG)
*!
*!
*!   Memory Files: &MFILENA
*!
*!*********************************************************************
PROCEDURE demotst1
PARAMETERS mfilena,trno

* this is a demonstration program to show how to test to see if an
* activation file is present, and set up some memory variables to
* control printing the letters if it is
* this routine, which is called as a udf will return true
* if the specification file is present, and there are active specifications
* for the trigger point passed to it

IF File("&mfilena")
   RESTORE FROM &mfilena ADDITIVE
   psn=1
   actltr(1)=0
   DO WHILE psn<=20              && lets test to see if any are applicable
      psns=LTRIM(STR(psn,2))
      IF ltr_trn&psns=trno       && if the trigger points match
         actltr(1)=actltr(1)+1   && increment the number of active specs
         temp=(actltr(1)+1)
         actltr(temp)=psns       && mark the letter position number
         ok=.T.                  && file exists, matching specs present
      ENDIF
      psn=psn+1
   ENDDO
   
   * the above routine will result in a public array which contains
   * the letter number (1-20) which is active for the trigger position number
   * passed to it.  If there are no active specifications for this point,
   * actltr(1) will be 0, otherwise it will be a number indicating how
   * many positions in the array are used, up to the full 20,
   *
   * positions 2 through 21 contain the character which indicates which
   * letter specification to use
   *
   * if you are not using the trigger position number, pass a 0 or whatever
   * you placed into the field, and all specifications in the file
   * will be placed in the selection array
ELSE
   ok=.F.   && if the file didn't exist, pass a false value back
ENDIF
RETURN ok



*!*********************************************************************
*!
*!      Procedure: DEMOTST2
*!
*!      Called by: DEMOBILL       (procedure in LTRUTL.PRG)
*!               : DEMOINV        (procedure in LTRUTL.PRG)
*!
*!          Calls: PRNLTR         (procedure in LTRUTL.PRG)
*!
*!*********************************************************************
PROCEDURE demotst2
PARAMETERS spcno

* this is a demonstration program to show how to test the activation file
* against the current record
* if the record passes, the letter is printed, if it fails, control is
* returned without printing the record.
* it is assumed the file you are testing is SELECTED
* the parameter is the number of the activation file to use
* note that it is a character variable, to use in the macro
passes=.F.
DO CASE
CASE ltr_trfn&spcno="All Names"
   passes=.T.
OTHERWISE
   tstfld=ltr_trfn&spcno                                   && get the field name
   IF &tstfld>=ltr_trl&spcno .AND. &tstfld<=ltr_trh&spcno  && test the expression
      passes=.T.                                           && ok???
   ENDIF
ENDCASE
IF passes                   && if it passed
   SELECT letter            && line up the letter
   SEEK ltr_ttl&spcno       && file
   SELECT main
   DO prnltr                && print it
ENDIF                       && reselect
SELECT main                 && the main datafile
RETURN                      && and return





*!*********************************************************************
*!
*!      Procedure: DEMOBILL
*!
*!      Called by: DEMO.PRG                      
*!
*!          Calls: DEMOTST1       (procedure in LTRUTL.PRG)
*!               : PSELECT        (procedure in LTRUTL.PRG)
*!               : DEMOTST2       (procedure in LTRUTL.PRG)
*!
*!           Uses: DEMO.DBF           Alias: MAIN
*!               : LETTER.DBF         Alias: LETTER
*!
*!        Indexes: DEMO.IDX
*!               : LETTER.IDX
*!
*!   Memory Files: DEMO.MEM
*!
*!*********************************************************************
PROCEDURE demobill
* this procedure is the dummy billing routine
* it simply runs through a set of names, and prints any letters if active
*
CLEAR
@00,00 TO 00,79 DOUBLE
@22,00 TO 22,79 DOUBLE
&vreverse
@00,03 SAY "Simulated Billing Run"
&vnormal
SELECT A
USE demo INDEX demo  ALIAS main
SELECT B
USE letter INDEX letter
@02,00
TEXT
Ŀ
  Simulated Billing Run                                                     
        This demonstration routine shows the process of printing a          
        letter automatically through a foxbase program.                     
        If there is an active specification for a letter present,           
        the program will inform you and ask for an output port.             
        If there are no letters, the program just processes the names.      

ENDTEXT
DIMENSION actltr(21)
isspecs=demotst1("DEMO.MEM",1)
IF isspecs
   RESTORE FROM demo ADDITIVE
   @12,03 SAY "There are "+LTRIM(STR(actltr(1),2))+" active letter specifications.."
   DO pselect WITH 14,10
ELSE
   RELEASE actltr
ENDIF
@23,00 SAY "Processing Billing Run..."
DO WHILE .NOT. EOF(1)
   @24,00 SAY "Processing Last Name - "+main->lname
   *
   *    billing code loop would be
   *           here!!
   *
   IF isspecs
      psn=1
      DO WHILE psn<=actltr(1)
         DO demotst2 WITH actltr(psn+1)
         psn=psn+1
      ENDDO
   ENDIF
   SELECT main
   SKIP
ENDDO
CLOSE DATA
RETURN

*!*********************************************************************
*!
*!      Procedure: DEMOINV
*!
*!      Called by: DEMO.PRG                      
*!
*!          Calls: DEMOTST1       (procedure in LTRUTL.PRG)
*!               : PSELECT        (procedure in LTRUTL.PRG)
*!               : DEMOTST2       (procedure in LTRUTL.PRG)
*!
*!           Uses: DEMO.DBF           Alias: MAIN
*!               : LETTER.DBF         Alias: LETTER
*!
*!        Indexes: DEMO.IDX
*!               : LETTER.IDX
*!
*!   Memory Files: DEMO.MEM
*!
*!*********************************************************************
PROCEDURE demoinv
* this procedure is the dummy invoice routine
* it simply runs through a set of names, and prints any letters if active
*
CLEAR
@00,00 TO 00,79 DOUBLE
@22,00 TO 22,79 DOUBLE
&vreverse
@00,03 SAY "Simulated Invoice Run"
&vnormal
SELECT A
USE demo INDEX demo  ALIAS main
SELECT B
USE letter INDEX letter
@02,00
TEXT
Ŀ
  Simulated Invoice Run                                                     
        This demonstration routine shows the process of printing a          
        letter automatically through a foxbase program.                     
        If there is an active specification for a letter present,           
        the program will inform you and ask for an output port.             
        If there are no letters, the program just processes the names.      

ENDTEXT
DIMENSION actltr(21)                && set up the array
isspecs=demotst1("DEMO.MEM",2)      && look for active letters for trigger point 2
IF isspecs
   RESTORE FROM demo ADDITIVE
   @12,03 SAY "There are "+LTRIM(STR(actltr(1),2))+" active letter specifications.."
   DO pselect WITH 14,10
ELSE
   RELEASE actltr              && if no specs, release the array
ENDIF
@23,00 SAY "Processing Invoice Run..."
DO WHILE .NOT. EOF(1)
   @24,00 SAY "Processing Last Name - "+main->lname
   *
   *    invoice code loop would be
   *           here!!
   *
   IF isspecs
      psn=1
      DO WHILE psn<=actltr(1)
         DO demotst2 WITH actltr(psn+1)
         psn=psn+1
      ENDDO
   ENDIF
   SELECT main
   SKIP
ENDDO
CLOSE DATA
RETURN

*: EOF: LTRUTL.PRG
